package ch.psi.daq.queryrest.response;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonGenerationException;
import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

// see: http://stackoverflow.com/a/15037329
public class JsonByteArraySerializer extends StdSerializer<byte[]> {
   private static final long serialVersionUID = -5914688899857435263L;

   public JsonByteArraySerializer() {
      super(byte[].class, true);
   }

   @Override
   public void serialize(byte[] bytes, JsonGenerator jgen, SerializerProvider provider) throws IOException,
         JsonGenerationException {
      jgen.writeStartArray();

      for (byte b : bytes) {
         // stackoverflow example used a mask -> ?
         jgen.writeNumber(b);
      }

      jgen.writeEndArray();
   }
}
