package ch.psi.daq.test.queryrest;

import javax.annotation.Resource;

import org.junit.Before;
import org.junit.runner.RunWith;
import org.mockito.MockitoAnnotations;
import org.springframework.boot.test.SpringApplicationConfiguration;
import org.springframework.test.annotation.DirtiesContext;
import org.springframework.test.annotation.DirtiesContext.ClassMode;
import org.springframework.test.context.TestExecutionListeners;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.support.DependencyInjectionTestExecutionListener;
import org.springframework.test.context.web.WebAppConfiguration;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.setup.MockMvcBuilders;
import org.springframework.web.context.WebApplicationContext;

import com.fasterxml.jackson.databind.ObjectMapper;

import ch.psi.daq.queryrest.QueryRestApplication;
import ch.psi.daq.queryrest.config.QueryRestConfig;
import ch.psi.daq.test.cassandra.CassandraDaqUnitDependencyInjectionTestExecutionListener;


@TestExecutionListeners({
   CassandraDaqUnitDependencyInjectionTestExecutionListener.class,
   DependencyInjectionTestExecutionListener.class})
@SpringApplicationConfiguration(classes = {
      QueryRestApplication.class 
      ,QueryRestConfig.class
      ,DaqWebMvcConfig.class
})
@DirtiesContext(classMode = ClassMode.AFTER_EACH_TEST_METHOD)
@WebAppConfiguration
@RunWith(SpringJUnit4ClassRunner.class)
public abstract class AbstractDaqRestTest {

   @Resource
   protected WebApplicationContext webApplicationContext;

   protected MockMvc mockMvc;

   @Resource
   protected ObjectMapper mapper;

   @Before
   public void setup() {
      // Process mock annotations
      MockitoAnnotations.initMocks(this);

      // Setup Spring test in webapp-mode (same config as spring-boot)
      this.mockMvc = MockMvcBuilders.webAppContextSetup(webApplicationContext).build();
   }

}
